/* TieTrackPixel.h */

#ifndef Included_TieTrackPixel_h
#define Included_TieTrackPixel_h

/* TieTrackPixel module depends on */
/* MiscInfo.h */
/* Audit */
/* Debug */
/* Definitions */
/* Array */
/* Memory */

struct TieTrackPixelRec;
typedef struct TieTrackPixelRec TieTrackPixelRec;

struct TieIntersectListRec;
typedef struct TieIntersectListRec TieIntersectListRec;

/* create a new tie pixel tracking object */
TieTrackPixelRec*		NewTieTrackPixel(void);

/* delete a tie pixel tracking object */
void								DisposeTieTrackPixel(TieTrackPixelRec* TieTrackPixel);

/* add a new point pair to the tracking thang */
MyBoolean						AddTieTrackPixelElement(TieTrackPixelRec* TieTrackPixel,
											long StartX, long StartY, long EndX, long EndY);

/* obtain an array of all ties which are in some manner intersecting the */
/* specified X interval */
TieIntersectListRec*	GetTieTrackPixelIntersecting(TieTrackPixelRec* TieTrackPixel,
											long XLocStart, long XLocWidth);

/* dispose of the tie intersection list */
void								DisposeTieTrackIntersectList(TieIntersectListRec* List);

/* find out how many elements there are in the intersection list */
long								GetTieTrackIntersectListLength(TieIntersectListRec* List);

/* get the drawing information about a particular tie thang */
void								GetTieTrackIntersectElement(TieIntersectListRec* List, long Index,
											long* StartX, long* StartY, long* EndX, long* EndY);

#endif
